/*  setBungOffset will set the offset for normal Bung carts.
    It copies the offset-switching code to RAM and then executes it.
    At the end of the execution is code that resets the GB, so it will
    start whatever was at that offset.

    You will not return from this function!!!
*/
void setBungOffset(char offset, char _cpu, char RAMuse_bank,
                   char ROMusage, char cartRAM);

// cartRAM = Cart RAM($80)/No Cart RAM($00)
// ROMusage = ROM Usage (0=32k,1=65k,3=128k,7=256k,f=512k,1f=1M,3f=2M)
// RAMuse_bank/hi nibble = RAM Usage (0=8k,3=32k)
// RAMuse_bank/lo nibble = RAM bank 0 offset in SRAM (8k byte increments)
// offset = ROM bank 0 offset in Flash (32k byte increments)
//        (Menu uses 0 so must be 1 or greater.)

void set_Bung_Offset(char offset, char RAMsize, char RAMoffset, char cartROM, char cartRAM)
{
   char RAMuse_bank;

   RAMuse_bank =  ((RAMsize & 0x0F) << 4) | (RAMoffset & 0x0F);

   setBungOffset(offset, _cpu, RAMuse_bank, cartROM, cartRAM);
}
