;;  BungAsm.s written by Ed Mandy (emandy@atcorp.com)
;;     Much of this code has been taken from other sources
	.area	_BSS
	;; Foreground drawing colour
.c000::
	.ds	1
.c001::
	.ds	1
.c002::
	.ds	1
.c003::
	.ds	1
CPUType::
	.ds	1

;#define DMG_TYPE 0x01 /* Original GB or Super GB */
;#define MGB_TYPE 0xFF /* Pocket GB or Super GB 2 */
;#define CGB_TYPE 0x11 /* Color GB */

	.area	_CODE

;;
;;  *****  Begin Bung offset setting code
;;
;;  Call setBungOffset(char offset) to set the offset and restart at that offset
;;
_setBungOffset::        ;new name
	CALL #copy_set_Bung_offset

   ;;set up .c000-.c003
   LD		A, #0

   LDA HL,6(SP)	; Skip return address and registers

   
   LD  A,(HL)	 
   LD  (.c000), A  ;Cart RAM($80)/No Cart RAM($00)
   DEC HL

   LD  A,(HL)	
   LD  (.c001), A  ;ROM Usage (0=32k,1=65k,3=128k,7=256k,f=512k,1f=1M,3f=2M)
   DEC HL

   LD  A,(HL)      ; c002/hi nibble = RAM Usage (0=8k,3=32k)
   LD  (.c002), A  ; c002/lo nibble = RAM bank 0 offset in SRAM (8k byte increments)
   DEC HL

   LD  A,(HL)	   ; make sure CPUType holds the GB type
   LD  (CPUType), A
   DEC HL
   LD  A,(HL)	   ; make sure c003 holds the offset to switch to
   LD  (.c003), A
   JP 0xD000


;
;  This code taken from BungCart.TXT (http://www.reinerziegler.de/)
;
; c000 = Cart RAM($80)/No Cart RAM($00)
; c001 = ROM Usage (0=32k,1=65k,3=128k,7=256k,f=512k,1f=1M,3f=2M)
; c002/hi nibble = RAM Usage (0=8k,3=32k)
; c002/lo nibble = RAM bank 0 offset in SRAM (8k byte increments)
; c003 = ROM bank 0 offset in Flash (32k byte increments)
;        (Menu uses 0 so must be 1 or greater.)
set_Bung_offset::
        di
        ld      a,#0
        ldh     (#0xFF),a
        ld      a,#0x0A
        ld      (#0x0000),a

; Switch to cart bank reconfigure mode

        ld      a,#0xC0
        ld      (#0x0000),a
        ld      a,#0xA1
        ld      (0xA000),a
        ld      a,(.c001)
        ld      (0xa100),a
        ld      a,#0xA2
        ld      (0xA000),a
        ld      a,(.c002)
        ld      (0xA100),a
        ld      a,#0xA3
        ld      (0xA000),a
        ld      A,(.c003)
        ld      (0xA100),a
        ld      a,#0xA0
        ld      (0xA000),a
        ld      a,#0xC0
        ld      (0xA100),a
        ld      a,#0
        ld      (0x4000),a
        ld      a,#0xA0
        ld      (0xA000),a
        ld      a,(.c000)
        ld      (0xA100),a

; Exit cart bank reconfigure mode

        ld      a,#0x0A
        ld      (0x0000),a

; Clear video ram
   LD HL,#0x8000
   LD DE,#0x2000
	LD A, #0x00
   LDH (#0x40), A						;.LCDC		= 0x40	; LCD control
.ClrLCDLoop$:
	LDH A,(0x41)             ;.STAT		= 0x41	; LCD status
   AND #0x02
   JR NZ, .ClrLCDLoop$
	LD A, #0x00
   LD (HL+),A
   DEC DE
   LD A, D
   OR E
   JR NZ, .ClrLCDLoop$

; Setup default video mode
        ld      a,#0x91
        ldh     (0x40),a


.waitWhileNZ$:
   ldh  a,(#0x41)
   and  #0x01
   jr   nz,.waitWhileNZ$
.waitWhileZ$:
   ldh  a,(#0x41)
   and  #0x01
   jr   z,.waitWhileZ$

; Initialize the stack

        ld      sp,#0xfffe

; Execute selected game in the multicart
	LD A, (CPUType)           ;(based on GB Type)  (CGB=0x11 GB=0x01 GBP=0xFF)
        jp      0x0100
end_of_set_Bung_offset:

copy_set_Bung_offset::
;copy set_PV_offset into RAM (D000)
	LD HL, #set_Bung_offset
   LD DE, #end_of_set_Bung_offset
   ;
   LD A,E         ; do DE=end_of_set_PV_offset-set_PV_offset (or DE-HL)
   SUB  L         ; E = A - L where A = E
   LD E,A
   LD A,D
   SBC  H         ; Sub and use the carry flag
   LD D,A         ; D = A - H where A = D
   ;					; Now, DE = the number of bytes to copy to RAM(0xD000)
   LD BC, #0xD000
.copy_Bung_loop$:
	LD A,(HL+)
   LD (BC),A
   INC BC
   DEC DE
   LD A, E
   OR D
   JP NZ,.copy_Bung_loop$
	RET

