//#define PVOICE 1
#include <gb.h>
#include <stdio.h>

#ifdef PVOICE
 #include "..\PVoice\PVoice.h"
#endif

#include "BungAsm.h"
//#include "EMSAsm.h"

#include "terminal.c"


#define VER_MAJ 0
#define VER_MIN 1

#define MENU_STARTY 2

unsigned char palString[4] = {128, 129, 130, 131};

unsigned char palTiles[] =
{
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
  0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,
  0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,
  0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,
  0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,
  0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
  0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
};

//this is the palette that will get set up.
//  if we're in color mode, then the BW games will get this palette
UWORD paletteCGB[4];
UWORD hardPaletteCGB[4] =
		{ RGB(31,31,31), RGB(20,20,20), RGB(10,10,10), RGB(0,0,0)};

struct _romInfo
{
   char romName[20];
   UBYTE ROMoffset;	//ROM bank 0 offset in Flash (32k byte increments)

   UBYTE cartROM;	//ROM Usage (0=32k,1=65k,3=128k,7=256k,f=512k,1f=1M,3f=2M)

   UBYTE cartRAM;	//Cart RAM($80)/No Cart RAM($00)
   UBYTE RAMsize;	//RAM Usage (0=8k,3=32k)
   UBYTE RAMoffset;	//RAM bank 0 offset in SRAM (8k byte increments)
} romInfo[20];

char arrowString[] = {26, 0}; //right arrow

char getRomNameStrings()
{
   char numFound, ramOffset;
   char i, j;

#ifdef PVOICE
   UBYTE *gameName = (UBYTE*)0x6134;
   UBYTE *ninLogo = (UBYTE*)0x6104;
   UBYTE *romSize = (UBYTE*)0x6148;//0x07=4076k,0x06=2048k
   UBYTE *ramSize = (UBYTE*)0x6149;//0x00=0k, 0x02=8k, 0x03=32k 
#else
   UBYTE *gameName = (UBYTE*)0x4134;
   UBYTE *ninLogo = (UBYTE*)0x4104;

   UBYTE *romSize = (UBYTE*)0x4148;
   //0x07=4076k,0x06=2048k,0x05=1024,0x04=512k,0x02=128k,0x01=64k,0x00=32k

   UBYTE *ramSize = (UBYTE*)0x4149;//0x00=0k, 0x02=8k, 0x03=32k 
#endif

   UBYTE *realNinLogo = (UBYTE*)0x0104;//this cart's logo (better be right)
   fixed fixed1;


   numFound = 0;
   ramOffset = 0;

   i = 0;   //0 should be menu rom.  (okay test case to set it to 1)
   do
   {
#ifdef PVOICE
      SWITCH_ROM_PV(i*4);
#else
      SWITCH_ROM_MBC5((UWORD)i*2);
#endif

      for(j = 0; j < 0x30; j++)  //check 0x30 bytes
      	if(realNinLogo[j] != ninLogo[j])
           break;

/*printf("i=%d,j=%d\n", i, j);
printf("realNinLogo[%d]=%x\n", j, realNinLogo[j]);
printf("ninLogo[%d]=%x\n", j, ninLogo[j]);
fixed1.w = (UWORD)ninLogo;
printf("nLogo h=0x%x l=0x%x\n", fixed1.b.h, fixed1.b.l);
while(!joypad());
waitpadup();*/

      if(j == 0x30)//it will be <0x30 if they didn't match
      {
         numFound++;

         strncpy(romInfo[numFound].romName, gameName, 16);
         romInfo[numFound].ROMoffset = i;

         if(*ramSize != 0)
         {
            romInfo[numFound].cartRAM = 0x80;	//Cart RAM($80)/No Cart RAM($00)

            romInfo[numFound].RAMoffset = ramOffset;
               //RAM bank 0 offset in SRAM (8k byte increments)

            if(*ramSize == 0x02)
            {
               ramOffset += 1;
               romInfo[numFound].RAMsize = 0x00;	//RAM Usage (0=8k,3=32k)
            }
            else  //otherwise, assume 32k
            {
               ramOffset += 4;
               romInfo[numFound].RAMsize = 0x03;	//RAM Usage (0=8k,3=32k)
            }
         }
         else
         {
            romInfo[numFound].cartRAM = 0;	//Cart RAM($80)/No Cart RAM($00)
            romInfo[numFound].RAMsize = 0;	//RAM Usage (0=8k,3=32k)

            romInfo[numFound].RAMoffset = ramOffset;	//really shouldn't be used, but zero it
         }

	 //ROM Usage (0=32k,1=65k,3=128k,7=256k,f=512k,1f=1M,3f=2M)
         romInfo[numFound].cartROM = ( 0xFF ^ (0xFF << *romSize) );
      }

      i++;

      //for now, we'll have a max of 15 ROMs
#ifdef PVOICE
   } while((i < 15) && (numFound < 15));  //max the PV can hold is 15
#else                                 
   } while((i < 127) && (numFound < 15));  //32M cart is 8 times larger than the PV (127)
#endif

#ifdef PVOICE
   SWITCH_ROM_PV(3);//switch back to 3
#else
   SWITCH_ROM_MBC5((UWORD)1);
#endif

   return numFound;
}

void printString(char x, char y, char *string)
{
   UBYTE strLen;

   strLen = strlen(string);

   set_bkg_tiles(x,y,strLen,1,(unsigned char *)string);
}

void printTitle()
{
   char tempString[30];

   printString(0, 0, "Welcome to Flavor's");
   sprintf(tempString, " PVoice Menu v%d.%d", VER_MAJ, VER_MIN);
   printString(0, 1, tempString);
}


void printMenu(char numRoms)
{
   char i;
   char tempString[30];
   char tempString2[30];

   cls();

   printTitle();

   for(i = 1; i <= numRoms; i++)
   {
/*      if(i < 10)
         sprintf(tempString, "0%d-%s", i, romInfo[i].romName);
      else
         sprintf(tempString, "%d-%s", i, romInfo[i].romName);
*/

     
      strncpy(tempString2, romInfo[i].romName, 5);
      tempString2[5] = 0;
      sprintf(tempString, "%s-%x-%x-%x-%x", tempString2, romInfo[i].cartRAM,
               romInfo[i].RAMsize, romInfo[i].cartROM, romInfo[i].ROMoffset);


      

      printString(1, i+MENU_STARTY, tempString);
   }

   //the palette is now a menu item
   printString(10, 2, "Colors");
   set_bkg_tiles(16, 2, 4, 1, palString);
}

void setPalettes()
{
   unsigned i;

   for(i = 0; i < 8; i++)
   {
      set_bkg_palette(i, 1, &paletteCGB[0]);
      set_sprite_palette(i, 1, &paletteCGB[0]);
   }
}

#ifdef PAL_CHOOSE
int paletteChooser()
{
   int joy = 0;
   char tempString[30];
   int r[4]={0};
   int g[4]={0};
   int b[4]={0};
   char i, pal, sub, x, y;
   UWORD paletteCGB2[4];
   UWORD savePalette[4];

   cls();

   set_bkg_palette(0, 1, hardPaletteCGB);  //make sure we can read stuff
   set_sprite_palette(0, 1, paletteCGB);   //the dynamic palette

   for(i = 0; i < 4; i++)
   {
      set_sprite_tile(i, i + 128); //tile n=n
      set_sprite_prop(i, 0); //palette 0

      set_sprite_tile(i+4, i + 128); //tile n=n
      set_sprite_prop(i+4, 0); //palette 0

      r[i] = paletteCGB[i] & 0x1F;
      g[i] = (paletteCGB[i] >> 5) & 0x1F;
      b[i] = (paletteCGB[i] >> 10) & 0x1F;

      paletteCGB2[i] = paletteCGB[0];

      move_sprite(i+4, (9+i)*8, 19*8);//draw a little palette at bottom
   }
   set_sprite_prop(0,1);//gonna use another palette for this one
   set_sprite_tile(0, 129); //spr0 is gonna be tile 129
   set_sprite_prop(4,1);//gonna use another palette for this one
   set_sprite_tile(4, 129); //spr0 is gonna be tile 129

   set_sprite_palette(1, 1, paletteCGB2);   //the hack palette for pal sprite 0

   memcpy(savePalette, paletteCGB, 4*sizeof(UWORD));

   //printTitle();

   printString(0, 0, "   Palette Editor   \0");
   printString(0, 2, "Exit Keys\0");
   printString(0, 3, "START-save changes  \0");
   printString(0, 4, "SELECT-load defaults\0");
   printString(0, 5, "B-cancel changes    \0");

   move_sprite(0, 2*8, 9*8);
   sprintf(tempString, "R = %d \0", r[0]);
   printString(3, 8, tempString);
   sprintf(tempString, "G = %d \0", g[0]);
   printString(3, 9, tempString);
   sprintf(tempString, "B = %d \0", b[0]);
   printString(3, 10, tempString);

   move_sprite(1, 2*8, 14*8);
   sprintf(tempString, "R = %d \0", r[1]);
   printString(3, 13, tempString);
   sprintf(tempString, "G = %d \0", g[1]);
   printString(3, 14, tempString);
   sprintf(tempString, "B = %d \0", b[1]);
   printString(3, 15, tempString);

   move_sprite(2, 12*8, 9*8);
   sprintf(tempString, "R = %d \0", r[2]);
   printString(13, 8, tempString);
   sprintf(tempString, "G = %d \0", g[2]);
   printString(13, 9, tempString);
   sprintf(tempString, "B = %d \0", b[2]);
   printString(13, 10, tempString);

   move_sprite(3, 12*8, 14*8);
   sprintf(tempString, "R = %d \0", r[3]);
   printString(13, 13, tempString);
   sprintf(tempString, "G = %d \0", g[3]);
   printString(13, 14, tempString);
   sprintf(tempString, "B = %d \0", b[3]);
   printString(13, 15, tempString);

   SHOW_SPRITES;

   pal = 0; //0-3
   sub = 0; //0=R 1=G 2=B
   x = 2;
   y = 8;
   printString(x, y, arrowString);  //draw new arrow
   while(!(joy & (J_START | J_B | J_SELECT)))
   {
      joy = joypad();

      if(joy & (J_UP | J_DOWN))
      {
	      if(joy & J_DOWN)
   	   {
      	   if(sub == 2)
         	{
	            pal++;
   	         sub = 0;
      	   }
         	else
	         {
   	         sub++;
      	   }

      	   if(pal > 3)
   	         pal = 0;
	      } //move down

      	if(joy & J_UP)
   	   {
	         if(sub == 0)
         	{
      	      pal--;
   	         sub = 2;
	         }
         	else
      	   {
   	         sub--;
	         }

         	if(pal < 0)
      	      pal = 3;

	      } //move up


         printString(x, y, " \0");  //draw new arrow
         switch(pal)
         {
            case 0:
               x = 2;
               y = 8 + sub;
               break;
            case 1:
               x = 2;
               y = 13 + sub;
               break;
            case 2:
               x = 12;
               y = 8 + sub;
               break;
            case 3:
               x = 12;
               y = 13 + sub;
               break;
         }
         printString(x, y, arrowString);  //draw new arrow
      }

      if(joy & (J_LEFT | J_RIGHT))
      {
         if(joy & J_LEFT)
         	i = -1;
         else //if(joy & J_RIGHT)
            i = 1;

         switch(sub)
         {
         	case 0://R
               r[pal] += i;
               if(r[pal] < 0)
               	r[pal] = 31;  //roll back
               else if(r[pal] > 31)
                  r[pal] = 0;   //roll over
            	break;
         	case 1://G
               g[pal] += i;
               if(g[pal] < 0)
               	g[pal] = 31;  //roll back
               else if(g[pal] > 31)
                  g[pal] = 0;   //roll over
            	break;
         	case 2://B
               b[pal] += i;
               if(b[pal] < 0)
               	b[pal] = 31;  //roll back
               else if(b[pal] > 31)
                  b[pal] = 0;   //roll over
            	break;
         }

         switch(pal)
         {
	         case 0:
			   sprintf(tempString, "R = %d \0", r[0]);
			   printString(3, 8, tempString);
		   	sprintf(tempString, "G = %d \0", g[0]);
			   printString(3, 9, tempString);
			   sprintf(tempString, "B = %d \0", b[0]);
			   printString(3, 10, tempString);
         	break;

            case 1:
			   sprintf(tempString, "R = %d \0", r[1]);
			   printString(3, 13, tempString);
			   sprintf(tempString, "G = %d \0", g[1]);
		   	printString(3, 14, tempString);
			   sprintf(tempString, "B = %d \0", b[1]);
			   printString(3, 15, tempString);
            break;

            case 2:
			   sprintf(tempString, "R = %d \0", r[2]);
			   printString(13, 8, tempString);
			   sprintf(tempString, "G = %d \0", g[2]);
		   	printString(13, 9, tempString);
			   sprintf(tempString, "B = %d \0", b[2]);
			   printString(13, 10, tempString);
            break;

            case 3:
			   sprintf(tempString, "R = %d \0", r[3]);
			   printString(13, 13, tempString);
			   sprintf(tempString, "G = %d \0", g[3]);
		   	printString(13, 14, tempString);
			   sprintf(tempString, "B = %d \0", b[3]);
			   printString(13, 15, tempString);
            break;
         }

   		paletteCGB[pal] = RGB(r[pal], g[pal], b[pal]);//set the new palette
         if(pal == 0)
         {
			   for(i = 0; i < 4; i++)
   	   	{
			      paletteCGB2[i] = paletteCGB[0];
		   	}
			   set_sprite_palette(1, 1, paletteCGB2);  //have to use a diff palette for sprite 0
         }
         else
         {
			   set_sprite_palette(0, 1, paletteCGB);   //the dynamic palette
         }

      }//if Left or Right

      if(joy)
      	delay(250);
   }
   waitpadup();

   HIDE_SPRITES;
   if(joy & J_B)
   {
      memcpy(paletteCGB, savePalette, 4*sizeof(UWORD));//fix it
      setPalettes();

   	return 0;//not successful
   }
   else if(joy & J_START)  //start saves the paletteCGB (already ready)
   {
      setPalettes();

      return 1;//successful
   }
   else //if(joy & J_SELECT)
   {
      memcpy(paletteCGB, hardPaletteCGB, 4*sizeof(UWORD));//load the default
      setPalettes();

      return 1;//successful
   }
}
#endif

void main(void)
{
   int joy;
   char offset = 1;
   char numRoms;//this will hold the number of roms that we found
   char i, j;
   char savePal = 0;
   char saveBuffer[30];

   char paletteString[8] = "Palette=";
   char tempString[30];
   char *RAM_DF00;
   char *ROM_7F00;

   RAM_DF00 = (char *)0xDF00;
   ROM_7F00 = (char *)0x7F00;

#ifdef PVOICE
   SWITCH_ROM_PV(3);
#else
   *(unsigned char *)0x6000 = 0x01;
   SWITCH_ROM_MBC5((UWORD)1);
#endif

   cls();

   VBK_REG = 0;
   set_bkg_data( 0, 132, terminalTiles );

   SPRITES_8x8;
   DISPLAY_ON;
   SHOW_BKG;

   //if there's one saved, use it, otherwise, use hardPaletteCGB (hard coded version)
   for(i = 0; i < 8; i++)
   {
      if(ROM_7F00[i] != paletteString[i])
         break;
   }
   if(i == 8)
   {
      memcpy(paletteCGB, &ROM_7F00[8], 4*sizeof(UWORD));
   }
   else
   {
      memcpy(paletteCGB, hardPaletteCGB, 4*sizeof(UWORD));
   }

   setPalettes();

   //the first thing that we should do is go collect all the info about the ROMs
   numRoms = getRomNameStrings();

   printMenu(numRoms);

   if(numRoms == 0)
   {
      printString(0, 8, "No ROMs found!!!");
      offset = 0;  //otherwise, it'll be 1
//      return;
   }

   if(offset)
	   printString(0,offset+MENU_STARTY, arrowString);
   else
	   printString(9, 2, arrowString);  //draw new arrow


   do
   {
      joy = joypad();

      if(joy & (J_SELECT | J_UP | J_DOWN))
      {
         if(offset == 0)  //the palette chooser
            printString(9, 2, " \0");  //draw new arrow
         else
            printString(0,offset+MENU_STARTY, " \0");  //erase old arrow

         if(joy & (J_SELECT | J_DOWN))
            offset++;
         else if(joy & J_UP)
            offset--;

         if(offset < 0)               //1 is the first, but palette is #0
            offset = numRoms;         //roll over to the last
         else if(offset > numRoms)    //numRoms-1 is the last
            offset = 0;               //roll back to the 1st

         if(offset == 0)  //the palette chooser
            printString(9, 2, arrowString);  //draw new arrow
         else
            printString(0,offset+MENU_STARTY, arrowString);  //draw new arrow

         delay(250);
      }

      if((offset == 0) && (joy & (J_A | J_START)) )
      {
#ifdef PAL_CHOOSE
         waitpadup();

         if(paletteChooser())
            savePal = 1;

         printMenu(numRoms);
         printString(9, 2, arrowString);  //draw new arrow
#endif

         joy = 0;  //eat the keypress
      }

   } while (!(joy & (J_A | J_START)));


   waitpadup();

   cls();
   printString(0, 3, "LOADING");
   sprintf(tempString, "ROM-%s", romInfo[offset].romName);
   printString(0, 5, tempString);
   sprintf(tempString, "  cartRAM=0x%x", romInfo[offset].cartRAM);
   printString(0, 6, tempString);
   sprintf(tempString, "  cartROM=0x%x", romInfo[offset].cartROM);
   printString(0, 7, tempString);
   sprintf(tempString, "  RAMsize=0x%x", romInfo[offset].RAMsize);
   printString(0, 8, tempString);
   sprintf(tempString, "  RAMoffset=0x%x", romInfo[offset].RAMoffset);
   printString(0, 9, tempString);
   sprintf(tempString, "  ROMoffset=0x%x", romInfo[offset].ROMoffset);
   printString(0, 10, tempString);
while(!joypad()) {}
waitpadup();

   DISPLAY_OFF;
   HIDE_BKG;

#ifdef PVOICE
   strcpy(saveBuffer, paletteString);
   memcpy(&saveBuffer[8], paletteCGB, 4*sizeof(UWORD));
   PVROMcpy(ROM_7F00, saveBuffer, 30, 3);

   setPVoffset(romInfo[offset].ROMoffset);           //will never return
#else
   set_Bung_Offset(romInfo[offset].ROMoffset, 
                   romInfo[offset].RAMsize,
                   romInfo[offset].RAMoffset,
                   romInfo[offset].cartROM,
                   romInfo[offset].cartRAM);
#endif
}
